package javax.net.ssl;

import java.security.Principal;
import javax.security.cert.X509Certificate;
import java.security.cert.Certificate;

public interface SSLSession
{
    public abstract byte[] getId();
    
    public abstract SSLSessionContext getSessionContext();
    
    public abstract long getCreationTime();
    
    public abstract long getLastAccessedTime();
    
    public abstract void invalidate();
    
    public abstract boolean isValid();
    
    public abstract void putValue(String p0, Object p1);
    
    public abstract Object getValue(String p0);
    
    public abstract void removeValue(String p0);
    
    public abstract String[] getValueNames();
    
    public abstract Certificate[] getPeerCertificates() throws SSLPeerUnverifiedException;
    
    public abstract Certificate[] getLocalCertificates();
    
    public abstract X509Certificate[] getPeerCertificateChain() throws SSLPeerUnverifiedException;
    
    public abstract Principal getPeerPrincipal() throws SSLPeerUnverifiedException;
    
    public abstract Principal getLocalPrincipal();
    
    public abstract String getCipherSuite();
    
    public abstract String getProtocol();
    
    public abstract String getPeerHost();
    
    public abstract int getPeerPort();
    
    public abstract int getPacketBufferSize();
    
    public abstract int getApplicationBufferSize();
}
